import Expression
import convert_re

def Str1(s):
    return Expression.Str(s)

def Str(*args):
    if len(args) == 1:
        return Str1(args[0])
    return Expression.Alt(tuple(map(Str, args)))

def Any(s):
    if len(s) == 1:
        return Expression.Literal(s)
    return Expression.In(s, 0)

def AnyBut(s):
    return Expression.In(s, 1)

def AnyChar(s):
    return Expression.Re("(?:.|\n)")


def Seq(*args):
    return Expression.Seq(args)

def Alt(*args):
    return Expression.Alt(args)

def Opt(expr):
    return Expression.MaxRepeat(expr, 0, 1)

def Rep(expr):
    return Expression.MaxRepeat(expr, 0)

def Rep1(expr):
    return Expression.MaxRepeat(expr, 1)

# Not in Plex
def MaxRepeat(expr, min_count, max_count = Expression.MAXREPEAT):
    return Expression.MaxRepeat(expr, min_count, max_count)
def RepN(expr, count):
    return Expression.MaxRepeat(expr, count, count)


def Eof():
    return Expression.AtEnd()

def Group(name, expr):
    return Expression.Subpattern(name, expr)

def Re(s):
    return convert_re.make_expression(s)

### Not really useful.  I thought it would be nice to remove the number
### of method calls, but it saves at best a fraction of a %.
##def select_names(expression, names):
##    exp = expression.copy()
##    exp._select_names(names)
##    return exp


# These are in Plex, but I don't (yet?) implement them

def NoCase(expr):
    raise NotImplementError

def Case(expr):
    raise NotImplementError

def Bol():
    raise NotImplementError

def Eol():
    raise NotImplementError

def Empty():
    raise NotImplementedError

